<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';
  import { DOWNLOAD_FLAG } from '~/helpers/constants';

  const props = defineProps<{
    product: Product;
  }>();

  const { t, locale } = useI18n();

  const availableStock = computed(() => props.product?.availableStock ?? 0);
  const minPurchase = computed(() => props.product?.minPurchase ?? 1);
  const willRelease = computed(() => {
    if (!props.product.releaseDate) return false;
    return new Date(props.product.releaseDate as string) > new Date();
  });
  const deliveryInformationText = computed(() => {
    const releaseDate = new Date(props.product.releaseDate as string);
    const day = releaseDate.getDate();
    const month = releaseDate.toLocaleDateString(locale.value, { month: 'long' });
    const year = releaseDate.getFullYear();

    return t('product.deliveryTime.deliveryShipping') + ' ' + `${day} ${month} ${year}`;
  });
</script>

<template>
  <div class="text-(xs information-dark) flex flex-col gap-2 font-medium">
    <div v-if="product.shippingFree" class="flex items-center gap-1">
      <span class="bg-shopware_brand-400 h-2.5 w-2.5 rounded-full" />
      {{ $t('product.deliverability.freeShipping') }}
    </div>
    <div v-if="!product.active" class="flex items-center gap-1">
      <span class="bg-crimson-900 h-2.5 w-2.5 rounded-full" />
      {{ $t('product.deliveryTime.deliveryNotAvailable') }}
    </div>
    <div v-else-if="willRelease" class="flex items-center gap-1">
      <span class="bg-pumpkin_spice-200 h-2.5 w-2.5 rounded-full" />
      {{ deliveryInformationText }}
    </div>
    <div
      v-else-if="
        (availableStock >= minPurchase ||
          (product.states.includes(DOWNLOAD_FLAG) && !product.isCloseout)) &&
        product.deliveryTime
      "
      class="flex items-center gap-1"
    >
      <span class="h-2.5 w-2.5 rounded-full bg-green-900" />
      {{
        $t('product.deliveryTime.available', {
          deliveryTime: getTranslatedProperty(product.deliveryTime, 'name'),
        })
      }}
    </div>
    <div
      v-else-if="product.isCloseout && availableStock < minPurchase"
      class="flex items-center gap-1"
    >
      <span class="bg-crimson-900 h-2.5 w-2.5 rounded-full" />
      {{ $t('product.deliveryTime.unavailable') }}
    </div>
    <div
      v-else-if="availableStock < minPurchase && product.deliveryTime && product.restockTime"
      class="flex items-center gap-1"
    >
      <span class="bg-pumpkin_spice-200 h-2.5 w-2.5 rounded-full" />
      {{
        $t('product.deliveryTime.restock', {
          deliveryTime: getTranslatedProperty(product.deliveryTime, 'name'),
          restockTime: product.restockTime,
        })
      }}
    </div>
  </div>
</template>
